/* fail.h */

#ifndef _fail_
#define _fail_

#define BOTTOM_EXN 0            /* "exc","Bottom" */
#define OUT_OF_MEMORY 1         /* "exc","Out_of_memory" */
#define OS_EXN 2                /* "unix","OS_error" */
#define FAILURE_EXN 3           /* "exc","failure" */
#define INVALID_EXN 4           /* "exc","Invalid_argument" */
#define END_OF_FILE_EXN 5       /* "io","End_of_file" */
#define ZERO_DIVIDE_EXN 6       /* "int","Division_by_zero" */

extern value exn_bucket;

#ifdef ANSI

extern void mlraise(value);
extern void failwith (char *);
extern void invalid_argument (char *);
extern void system_failwith_out_of_memory (void);
extern void os_error(void);

#else /* ANSI */

extern void mlraise();
extern void failwith ();
extern void invalid_argument ();
extern void system_failwith_out_of_memory ();
extern void os_error();

#endif /* ANSI */

#endif /* _fail_ */
